/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var usersJSON="";
var curUserIdx=0;

function InstantiateXHR(){
    var xmlReq=false;
    // Most navigators (firefox, chrome, opera, safari etc.) support XMLHttpRequest
    if (window.XMLHttpRequest){
        xmlReq=new XMLHttpRequest();
    } else if (window.ActiveXObject) {
        try {   // iE5,6
                xmlReq=new ActiveXObject(Msxml2.XMLHTTP);
             } catch(e1) {
                try { // IE 7 and +
                    xmlReq=new ActiveXObject(Microsoft.XMLHTTP);
                } catch (e2) {
                    return null;
            }
        }
    }
    return  xmlReq;
}

function getReadyStateHandlerXML(req, responseXMLHandler){
    return function (){
        if (req.readyState===4 && req.status===200)  {
            if (null!==req.responseXML) 
                responseXMLHandler(req.responseXML);
            else 
                alert("Le contenu du flux XML est vide !");
        }
    };
    
}

function getReadyStateHandlerText(req, responseJSONHandler){
    return function (){
        if (req.readyState===4 && req.status===200)  {
            if (null!==req.responseText) 
                responseJSONHandler(req.responseText);
            else 
                alert("Le contenu du flux JSON est vide !");
        }
    };
    
}



function GetUserInfosBtn(){
    var req=InstantiateXHR();
    if (req===null) return;
    
    req.onreadystatechange=getReadyStateHandlerText(req, getUserInfos);
    var urlString="crud=getAll";
    req.open("post", "UserCRUD", true);
    req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    req.send(urlString);
    
}


function formattedDate(date) {
    date=date.replace("fév", "feb"); date=date.replace("mars", "march"); 
    date=date.replace("avr", "apr"); date=date.replace("mai", "may"); date=date.replace("juin", "june");
    date=date.replace("juil", "july"); date=date.replace("aoû", "aug"); date=date.replace("déc", "dec");
    
    var d = new Date(date || Date.now()),
        month = '' + (d.getMonth() + 1),
        day = '' + d.getDate(),
        year = d.getFullYear();

    if (month.length < 2) month = '0' + month;
    if (day.length < 2) day = '0' + day;

    return [year, month, day].join('-');
}

function getUserInfos(JSONResult){
    Enable("next",false),Enable("previous",false),Enable("first",false),Enable("last",false);
    if (JSONResult==="") return;
    document.getElementById("counter").innerText="";
    usersJSON=JSONResult;
    var obj = JSON.parse(JSONResult);
    if (obj===null) return;
    document.getElementById("id").value=obj[0].id;
    document.getElementById("nom").value=obj[0].nom;
    document.getElementById("prenom").value=obj[0].prenom;
    document.getElementById("email").value=obj[0].email;
    document.getElementById("pwd").value=obj[0].pwd;
    document.getElementById("dateNaissance").value=formattedDate(obj[0].dateNaissance);
    document.getElementById("message").style.color="green";
    document.getElementById("message").innerText="Users info retreived successfully.";
    if (obj.length) {
        document.getElementById("counter").innerText="1 on " + obj.length;
        Enable("next",true),Enable("previous",true),Enable("first",true),Enable("last",true);
        curUserIdx=0;
    }
}

function Enable(id, tag){
    document.getElementById(id).disabled=!tag;
}


function getNextOrPrevious(tag){
    if (usersJSON==="") return;
    var obj = JSON.parse(usersJSON);
    if (obj.length>0) Enable("next",true),Enable("previous",true),Enable("first",true),Enable("last",true);
    if (tag==="next") {
        if (curUserIdx>=-1+obj.length) {
            curUserIdx=obj.length-1; Enable("next",false),Enable("previous",true),Enable("first",true),Enable("last",false);return;
        }
        else curUserIdx=curUserIdx+1;
    } else if (tag==="previous") {
        if (curUserIdx<=0) {curUserIdx=0; Enable("next",true),Enable("previous",false),Enable("first",false),Enable("last",true);return;}
        else curUserIdx=curUserIdx-1;
    }else if (tag==="first") {
        curUserIdx=0;
    }else if (tag==="last") {
        curUserIdx=obj.length-1;
    }
    if (obj===null) return;
    document.getElementById("id").value=obj[curUserIdx].id;
    document.getElementById("nom").value=obj[curUserIdx].nom;
    document.getElementById("prenom").value=obj[curUserIdx].prenom;
    document.getElementById("email").value=obj[curUserIdx].email;
    document.getElementById("pwd").value=obj[curUserIdx].pwd;
    document.getElementById("dateNaissance").value=formattedDate(obj[curUserIdx].dateNaissance);
    document.getElementById("counter").innerText=(1+curUserIdx) + ' on '+obj.length;
    
    if (curUserIdx===0) Enable("first",false), Enable("previous",false);
    if (curUserIdx+1===obj.length) Enable("last",false),Enable("next",false);
}

function ResetFields(){
    document.getElementById("id").value="";
    document.getElementById("nom").value="";
    document.getElementById("prenom").value="";
    document.getElementById("email").value="";
    document.getElementById("pwd").value="";
    document.getElementById("dateNaissance").value="";
}


function GetSearchWhat() {
    document.getElementById("searchWhatVal").value=document.getElementById("searchWhat").value;
}
function GetSearchBy() {
    var list=document.getElementById("searchBy");
    var searchBy=list.options[list.selectedIndex].value;
    if (searchBy!==null) document.getElementById("searchByVal").value= searchBy;
    document.getElementById("searchWhat").focus();
}

function GetSearchResult(){
    var req=InstantiateXHR();
    if (req===null) return;
    
    var list=document.getElementById("searchBy");
    var searchBy=list.options[list.selectedIndex].value;
    var searchWhat=document.getElementById("searchWhat").value;
    
    req.onreadystatechange=getReadyStateHandlerText(req, getUserInfos);
    var urlString="crud=search&searchByVal="+searchBy+"&searchWhatVal="+searchWhat;  
    
    req.open("post", "UserCRUD", true);
    req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    req.send(urlString);
}

