/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.yezza.dao;

import java.sql.ResultSet;
import java.util.concurrent.atomic.AtomicReference;
import com.yezza.business.User;

/**
 *
 * @author ayezza
 */
public interface IUser {
    public boolean addUser(User pUser, AtomicReference<String> errorMsg);
    public boolean delUser(User pUser, AtomicReference<String> errorMsg);
    public boolean updateUser(User pInUser, AtomicReference<String> errorMsg);
    public String getAllUsers();    // get JSON represntation of all users
    public ResultSet getAllUsersResultSet();    // get the resultset of all users
    public String getUserById(int pId); // get JSON represntation of users with pId serach
    public String getUsersByName(String pName);     // get JSON represntation of users with pName serach
    public String getUsersByPrenom(String pPrenom); // get JSON represntation of users with pPrenom serach
    public String getUserByEmail(String pEmail); // get JSON represntation of users with pEmail serach
}
